searchNodes=[{"doc":"This module provides the ability to combine multiple rate limiters together.{ExqLimit.And, [ {ExqLimit.Local, limit: 20}, {ExqLimit.Global, limit: 100}, {ExqLimit.GCRA, [period: :second, rate: 60, burst: 0], short_circuit: true} ] }The above example creates a rate limiter which dequeues new jobs only if all the rate limiters return true. This can be used to create interesting combinations and also supports custom rate limiters as long as it implements the Exq.Dequeue.Behaviour behaviourOptionsshort_circuit (boolean) - whether to short circuit the Exq.Dequeue.Behaviour.available?/1 call when any one of the previous rate limiters returned false. Defaults to false.Some of the modules in ExqLimit expect specific value to be set for short_circuit option, otherwise the behaviour is undefined when used with ExqLimit.And. Order is also important, those with short_circuit: true should be placed last.moduleshort_circuitExqLimit.Localtrue or falseExqLimit.GlobalfalseExqLimit.GCRAtrue","ref":"ExqLimit.And.html","title":"ExqLimit.And","type":"module"},{"doc":"This module implements the GCRA algorithm. Check the blog post by brandur for an excellent introduction.Example{ExqLimit.GCRA, period: :hour, rate: 60}The above config can be used to run 60 jobs per hour. The algorithm only allows jobs at regular interval, so if 10 jobs get enqueued at once, each one will get processed at 1 minute interval.{ExqLimit.GCRA, period: :hour, rate: 60, burst: 5}burst option provides the ability to overshoot the limit for a short period of time. It can be compared to a battery. With the above config, when it's fully charged, it can process 5 jobs immediatly, but from 6th job onwards, it will process jobs at 1 minute interval. The battery will get recharged 1 point every minute and get maxed at 5.Optionsperiod (atom | integer) - Can be either :second, :minute, :hour, :day. In case of integer, it will be consider as seconds. Required field.burst (integer) - Number of jobs allowed over the limit. Defaults to 0local (boolean) - if set to true, the rate limiting will apply to the local worker node. Otherwise, the rate limiting will apply to all worker nodes. Defaults to false.node_id (string) - Unique id of the worker node. Defaults to Exq node identifier. This will be used only if local option is set to true.CreditsThe lua script used in this module is a slightly modified version of redis-gcra","ref":"ExqLimit.GCRA.html","title":"ExqLimit.GCRA","type":"module"},{"doc":"Exq comes with concurrency control support per queue, but it's limited to a single worker node. This module on the other hand limits the concurrency globally across all the worker nodes. For example, with a limit of 10, if there are two active worker nodes, each will be allowed to work on 5 concurrent jobs. The limits per worker node will get auto adjusted when new worker nodes get added or existing ones get removed.Optionslimit (integer) - Global max concurrency across all the worker nodes. Required fieldnode_id (string) - Unique id of the worker node. Defaults to Exq node identifier.interval (integer - milliseconds) - The availability of each node is determined by the last hearbeat. The interval controls how often the node registers the hearbeat. Defaults to 20_000.missed_heartbeats_allowed (integer) - Number of hearbeats a node is allowed to miss. After which, the node will be considered dead and its capacity will be redistributed to remaining worker nodes. Defaults to 10.NOTESThis implementations tries to never run more than the configured limit. But the limit could be crossed if a node could not communicate with redis server, but able to continue with current running jobs. In those cases, after certain time, the node will be considered dead and its capacity will be shared across remaining nodes.","ref":"ExqLimit.Global.html","title":"ExqLimit.Global","type":"module"},{"doc":"It limits the total number of concurrent jobs on a single node. same as the Exq default rate limiter.In isolation, this limiter is not that much useful, but it can be combined with other rate limiters to get intersting results. For example, it can be combined with ExqLimit.Global rate limiter to make sure a single node doesn't get overloaded when total the number of live worker nodes go down due to unexpected reason. Check the documentation of ExqLimit.And on how to combine rate limitersOptionslimit (integer) - max concurrency allowed. Required field","ref":"ExqLimit.Local.html","title":"ExqLimit.Local","type":"module"},{"doc":"ExqLimit ExqLimit implements different types of rate limiting for Exq queue.","ref":"readme.html","title":"ExqLimit","type":"extras"},{"doc":"config :exq, queues: [{&quot;default&quot;, {ExqLimit.Global, limit: 10}}]","ref":"readme.html#example","title":"ExqLimit - Example","type":"extras"},{"doc":"ExqLimit.Global - Global concurrency limit across all worker nodes.ExqLimit.Local - Local concurrency limit for a worker node.ExqLimit.GCRA - An implementation of GCRA algorithm.ExqLimit.And - A limiter which allows to combine other limiters.","ref":"readme.html#types","title":"ExqLimit - Types","type":"extras"}]